#
# Conditional build:
%bcond_with	glide2_sdk	# build Glide2x_SDK here (normally built from Glide_V3.spec)
#
Summary:	Glide runtime for 3Dfx Voodoo Graphics boards
Summary(pl.UTF-8):	Środowisko Glide dla kart 3Dfx Voodoo Graphics
Name:		Glide_VG
Version:	2.46
Release:	11
License:	3DFX GLIDE Source Code General Public License
Group:		Libraries
Source0:	Glide%{version}.tar.gz
# Source0-md5:	be7762636b46cb04b238a16f45cfcfa8
Patch0:		%{name}-asm.patch
Patch1:		%{name}-opt.patch
Patch2:		%{name}-morearchs.patch
Patch3:		%{name}-ioctl.patch
Patch4:		%{name}-soname.patch
Patch5:		%{name}-C_brainos.patch
Patch6:		%{name}-format.patch
Patch7:		%{name}-include.patch
URL:		http://glide.sourceforge.net/
%ifarch %{ix86}
BuildRequires:	/usr/bin/gasp
%endif
BuildRequires:	xorg-lib-libX11-devel
BuildRequires:	xorg-lib-libXxf86dga-devel
BuildRequires:	xorg-lib-libXxf86vm-devel
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This library allows the user to use a 3Dfx Interactive Voodoo Graphics
card under Linux.

%description -l pl.UTF-8
Ten pakiet pozwala na używanie kart 3Dfx Interactive Voodoo Graphics
pod Linuksem.

%package devel
Summary:	Development package for Glide 2.x built for Voodoo Graphics
Summary(pl.UTF-8):	Pakiet programistyczny dla Glide 2.x zbudowanego dla Voodoo Graphics
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	Glide2x_SDK >= %{version}
Provides:	Glide2x-devel = %{version}

%description devel
Development package for Glide 2.x built for 3Dfx Interactive Voodoo
Graphics adapters.

%description devel -l pl.UTF-8
Pakiet programistyczny dla Glide 2.x zbudowanego dla kart 3Dfx
Interactive Voodoo Graphics.

%package -n Glide2x_SDK
Summary:	Development files for Glide 2.x
Summary(pl.UTF-8):	Część Glide 2.x przeznaczona dla programistów
Group:		Development/Libraries
Conflicts:	Glide_SDK

%description -n Glide2x_SDK
This package includes the headers files, documentation, and test files
necessary for developing applications that use the 3Dfx Interactive
Voodoo Graphics, Voodoo Rush, or Voodoo2 card.

%description -n Glide2x_SDK -l pl.UTF-8
Ten pakiet zawiera pliki nagłówkowe, dokumentację i pliki testowe
potrzebne do tworzenia aplikacji używających kart 3Dfx Interactive
Voodoo Graphics, Voodoo Rush lub Voodoo2.

%prep
%setup -q -c
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
chmod +x swlibs/include/make/ostype

%build
%{__make} -j1 -f makefile.unix \
	CC="%{__cc}" \
	CNODEBUG="%{rpmcflags} -fPIC %{!?debug:-fomit-frame-pointer} \
	%{!?debug:-funroll-loops -fexpensive-optimizations -ffast-math}" \
%ifnarch %{ix86}
	FX_GLIDE_CTRISETUP=1
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_libdir},%{_bindir}}

# Install the glibc 2.1 libraries normally
install sst1/lib/libglide.so.2.46 $RPM_BUILD_ROOT%{_libdir}
ln -sf libglide.so.2.46 $RPM_BUILD_ROOT%{_libdir}/libglide.so.2
ln -sf libglide.so.2 $RPM_BUILD_ROOT%{_libdir}/libglide2x.so
ln -sf libglide.so.2 $RPM_BUILD_ROOT%{_libdir}/libglide.so
install swlibs/lib/libtexus.so.1.1 $RPM_BUILD_ROOT%{_libdir}
ln -sf libtexus.so.1.1 $RPM_BUILD_ROOT%{_libdir}/libtexus.so.1
ln -sf libtexus.so.1 $RPM_BUILD_ROOT%{_libdir}/libtexus.so

# Install the executables
install swlibs/bin/texus $RPM_BUILD_ROOT%{_bindir}
install sst1/glide/tests/test00 $RPM_BUILD_ROOT%{_bindir}/test3Dfx

%if %{with glide2_sdk}
### SDK
install -d $RPM_BUILD_ROOT%{_includedir}/glide \
	$RPM_BUILD_ROOT%{_examplesdir}/glide2x-%{version}/{tests,texus/examples}

# Install the headers
install swlibs/include/3dfx.h $RPM_BUILD_ROOT%{_includedir}/glide
install sst1/include/glide.h $RPM_BUILD_ROOT%{_includedir}/glide
install sst1/include/glidesys.h $RPM_BUILD_ROOT%{_includedir}/glide
install sst1/include/glideutl.h $RPM_BUILD_ROOT%{_includedir}/glide
install sst1/include/sst1vid.h $RPM_BUILD_ROOT%{_includedir}/glide
install sst1/include/gump.h $RPM_BUILD_ROOT%{_includedir}/glide
install swlibs/include/linutil.h $RPM_BUILD_ROOT%{_includedir}/glide
install swlibs/include/texus.h $RPM_BUILD_ROOT%{_includedir}/glide

# Install the examples and their source
install sst1/glide/tests/makefile.distrib $RPM_BUILD_ROOT%{_examplesdir}/glide2x-%{version}/tests/makefile
install sst1/glide/tests/*.3df $RPM_BUILD_ROOT%{_examplesdir}/glide2x-%{version}/tests
install sst1/glide/tests/test??.c $RPM_BUILD_ROOT%{_examplesdir}/glide2x-%{version}/tests
install sst1/glide/tests/tldata.inc $RPM_BUILD_ROOT%{_examplesdir}/glide2x-%{version}/tests
install sst1/glide/tests/tlib.[ch] $RPM_BUILD_ROOT%{_examplesdir}/glide2x-%{version}/tests
gzip -9nf $RPM_BUILD_ROOT%{_examplesdir}/glide2x-%{version}/tests/*.3df

# Install the texture tools source
install swlibs/texus/examples/makefile.distrib $RPM_BUILD_ROOT%{_examplesdir}/glide2x-%{version}/texus/examples/makefile
install swlibs/texus/examples/*.c $RPM_BUILD_ROOT%{_examplesdir}/glide2x-%{version}/texus/examples
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc glide_license.txt readme.txt
%attr(755,root,root) %{_bindir}/texus
%attr(755,root,root) %{_bindir}/test3Dfx
%attr(755,root,root) %{_libdir}/libglide.so.2.46
%attr(755,root,root) %ghost %{_libdir}/libglide.so.2
%attr(755,root,root) %{_libdir}/libglide2x.so
%attr(755,root,root) %{_libdir}/libtexus.so.1.1
%attr(755,root,root) %ghost %{_libdir}/libtexus.so.1
%attr(755,root,root) %{_libdir}/libtexus.so

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libglide.so

%if %{with glide2_sdk}
%files -n Glide2x_SDK
%defattr(644,root,root,755)
%doc docs/*.pdf
%{_includedir}/glide
%{_examplesdir}/glide2x-%{version}
%endif
%changelog
* Sat Sep 21 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/Glide_VG.git;a=log;h=master

* Sat Sep 21 2013 Jakub Bogusz <qboosh@pld-linux.org> 0c0bac1
- added format patch (fixes build with -Werror=format-security)
- added include patch (avoid includes nested in function)
- release 11

* Sun Jan 15 2012 Jakub Bogusz <qboosh@pld-linux.org> 3b38075
- versioned Glide2x-devel Provides

* Sun Jan 15 2012 Jakub Bogusz <qboosh@pld-linux.org> ac1d23c
- added glide2_sdk bcond (off by default, glide2x will be built from Glide_V3.spec)
- added -devel subpackage - almost metapackage, with just libglide.so (libglide2x.so is used for dlopen, so must stay in base)

* Sat Jan 14 2012 Jakub Bogusz <qboosh@pld-linux.org> 46c6bc1
- removed texus sources from SDK

* Sat Jan 14 2012 Jakub Bogusz <qboosh@pld-linux.org> 403fc47
- provide libglide.so symlink too

* Sat Jan 14 2012 Jakub Bogusz <qboosh@pld-linux.org> d20f55c
- Glide2x_SDK Conflicts: Glide_SDK

* Fri Jan 13 2012 Jakub Bogusz <qboosh@pld-linux.org> bb15827
- I don't see any reason to use 2.1 as SDK version; the version is 2.46
- use versioned dir for examples

* Fri Jan 13 2012 Jakub Bogusz <qboosh@pld-linux.org> d8c2746
- updated soname patch to use sonames compatible with later versions of glide2x
  (libglide.so.2, libtexus.so.1); keep libglide2x.so, libtexus.so symlinks

* Sun Jan 08 2012 Jakub Bogusz <qboosh@pld-linux.org> c38e5d2
- pass CC

* Sun Jan 08 2012 Jakub Bogusz <qboosh@pld-linux.org> ca5929e
- updated to use modern xorg implementation instead of X11R6
- updated URL (3dfx.com is dead, use sf project page)
- package readme.txt

* Sat Jan 29 2011 sparky <sparky@pld-linux.org> dde689e
- dropped pre-cvs changelog

* Tue Mar 06 2007 spider <spider@pld-linux.org> 6eab994
- rel++
- STBR

* Mon Feb 12 2007 Elan Ruusamäe <glen@pld-linux.org> 61beb79
- tabs in preamle

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> a216d7c
- converted to UTF-8

* Sat Jan 21 2006 Arkadiusz Miśkiewicz <arekm@maven.pl> 263882a
- kill Icon: field (support for these is obsolete says jbj)

* Mon Apr 18 2005 Mariusz Mazur <mmazur@pld-linux.org> 2665248
- rel 9; builds with gcc4

* Mon Apr 18 2005 Mariusz Mazur <mmazur@pld-linux.org> 2942135
- gcc4 notices lots of brainos

* Sat Sep 25 2004 tommat <tommat@pld-linux.org> 753c842
- no parallel build

* Sat Apr 24 2004 Jakub Bogusz <qboosh@pld-linux.org> fe94377
- added soname patch (fixes deps generated in base)
- compress *.3df files in tests
- release 8

* Sat Apr 24 2004 Jakub Bogusz <qboosh@pld-linux.org> b14c4c1
- add soname to libs

